package PetitTemplate;

#use strict;
#use warnings;
use vars qw(@ISA @EXPORT @EXPORT_OK $VERSION $esclist $explist $expfunc);
require Exporter;
@ISA       = qw(Exporter);
@EXPORT    = qw();
@EXPORT_OK = qw();
$VERSION   = 1.08;
$esclist   = esclist();
$explist   = explist();
$expfunc   = expfunc();

#---

# PetitTemplate - ɓIȃeLXgev[gVXe

#---

# ȒPȎgp

# * test.tmpl
# 
# ---- [% subj %] ----
# [% loop=pref %]
# Pref: [% name %] >> [% weather %]
# [% /loop %]

# use PetitTemplate;
# my $q = new PetitTemplate(
# 	filename => 'test.tmpl',
# );
# $q->param({
# 	subj => 'Japan Weather',
# 	pref => [
# 		{ name => 'Tokyo', weather => 'Fair'   },
# 		{ name => 'Osaka', weather => 'Croudy' },
# 	],
# });
# print $q->output();

#---

sub new($;@){
	my($class,@init) = @_;
	my($init,$ltag,$rtag);
	my $self = { tobj => [], vars => {} };

	$init = pinit(@init);
	($ltag,$rtag) = tptag(($init->{'ltag'} || ''),($init->{'rtag'} || ''));

	if(ref($init->{'dmpobj'}) eq 'ARRAY'){
		$self->{'tobj'} = $init->{'dmpobj'};
	}elsif(ref($init->{'scalarref'}) eq 'SCALAR'){
		$self->{'tobj'} = parser($ltag,$rtag,${$init->{'scalarref'}},'');
	}else{
		$self->{'tobj'} = parser($ltag,$rtag,'',$init->{'filename'});
	}

	bless($self,(ref($class) || $class));
	return($self);
}

sub param($;@){
	my($self,@vars) = @_;
	$self->{'vars'} = pinit(@vars);
	return($self);
}

sub dmpobj($){
	my($self) = @_;
	return($self->{'tobj'});
}

sub output($){
	my($self) = @_;
	return(join('',@{ append($self->{'tobj'},$self->{'tobj'},$self->{'vars'},utilv($self->{'vars'})) }));
}

#---

sub pinit(@){
	return((ref($_[0]) eq 'HASH') ? $_[0] : ((scalar(@_) % 2) == 0) ? { @_ } : {});
}

sub tptag($$){
	my($ltag,$rtag) = @_;
	return((($ltag =~ /\S/) && ($rtag =~ /\S/)) ? ($ltag,$rtag) : ('\[\%','\%\]'));
}

sub utilv($){
	my($vars) = @_;
	return((ref($vars->{'util'}) eq 'HASH') ? { util => $vars->{'util'} } : {});
}

#---

sub parser($$$$){
	my($ltag,$rtag,$tmpl,$path) = @_;
	my(@temp,@tobj);
	my($item,$type,$name,$opt);
	my($tree,$nobj,@loop,@bool);

	$tmpl = (($path ne '') ? readt($path,0,$ltag,$rtag) : '') if($tmpl !~ /\S/);
	$tmpl =~ s/(?:\t*)(?:(?:$ltag)\#)(?:.*?)(?:\#(?:$rtag))(?:\n?)//sg;
	$tmpl =~ s/(?:\t*)(?:$ltag)\s*(?:include\=(?:[^\"\']|([\"\'])(?:[^\\\1]|\\[\\\1])*?\1)*?)\s*(?:$rtag)(?:\n?)//g; #"
	$tmpl =~ s/(?:\t*)((?:$ltag)\s*(?:\w+\=(?:[^\"\']|([\"\'])(?:[^\\\2]|\\[\\\2])*?\2)*?|\/\w+|else)\s*(?:$rtag))(?:\n?)/$1/g; #"
	@temp = split(/((?:$ltag)\s*(?:(?:[^\"\']|\"(?:(?:[^\\\"]|\\[\\\"])*?)\"|\'(?:(?:[^\\\']|\\[\\\'])*?)\')*?)\s*(?:$rtag))/,$tmpl); #"
	$tree = \@tobj;
	undef $tmpl;

	$ltag = qr/^(?:$ltag)\s*/;
	$rtag = qr/\s*(?:$rtag)$/;
	while(defined($item = shift(@temp))){
		if(($item =~ /$ltag/) && ($item =~ /$rtag/) && ($item =~ s/$ltag//) && ($item =~ s/$rtag//)){
			($type,$name,$opt) = ptype($item);
			if($type eq 'loop'){
				$nobj = { type => 'loop', name => $name, opt => $opt, loop => [] };
				push(@loop ,$tree);
				push(@$tree,$nobj);
				$tree = $nobj->{'loop'};
			}elsif($type eq '/loop'){
				$tree = pop(@loop) if(0 < scalar(@loop));
			}elsif($type eq 'rloop'){
				push(@$tree,{ type =>'loop', name => $name, opt => $opt, loop => undef });
			}elsif(($type eq  'if') || ($type eq  'unless')){
				$nobj = { type => 'bool', check => [], false => [] };
				push(@bool ,$tree);
				push(@$tree,$nobj);
				$nobj = $nobj->{'check'};
				push(@$nobj,{ type => $type, name => $name, opt => $opt, true => [] });
				$tree = $nobj->[-1]->{'true'};
			}elsif($type =~ /^(?:else?)(if|unless)$/){
				next if((scalar(@bool) == 0) || (scalar(@{$bool[-1]}) == 0));
				$nobj = $bool[-1]->[-1]->{'check'};
				push(@$nobj,{ type =>    $1, name => $name, opt => $opt, true => [] });
				$tree = $nobj->[-1]->{'true'};
			}elsif($type eq 'else'){
				next if((scalar(@bool) == 0) || (scalar(@{$bool[-1]}) == 0));
				$tree = $bool[-1]->[-1]->{'false'};
			}elsif(($type eq '/if') || ($type eq '/unless')){
				$tree = pop(@bool) if(0 < scalar(@bool));
			}elsif($type eq 'var'){
				push(@$tree,{ type => 'var', name => $name, opt => $opt });
			}
		}else{
			push(@$tree,$item) if($item ne '');
		}
	}

	return(\@tobj);
}

sub append($$$$){
	my($tree,$recr,$vars,$util) = @_;
	my(@text,$item,$loop,@data,$cnt);

	foreach $item (@$tree){
		if(ref($item) eq 'HASH'){
			if($item->{'type'} eq 'loop'){
				$loop = $item->{'loop'} || $recr;
				@data = getl($item->{'name'},$item->{'opt'},$vars,$util);
				foreach $cnt (0 .. $#data){
					push(@text,@{ append($loop,$loop,{ %$util,lvars(\@data,$cnt),%{$data[$cnt]} },$util) });
				}
			}elsif($item->{'type'} eq 'bool'){
				push(@text,@{ append(slctb($item->{'check'},$item->{'false'},$vars),$recr,$vars,$util) });
			}elsif($item->{'type'} eq 'var'){
				push(@text,getv($item->{'name'},$item->{'opt'},$vars));
			}
		}else{
			push(@text,$item);
		}
	}

	return(\@text);
}

#---

sub ptype($){
	my($item) = @_;
	return(($item =~ /^(r?loop|(?:else?)?(?:if|unless))\=(.*?)$/s) ? ($1,pname($2))
	: ($item =~ /^(?:\/(?:loop|if|unless)|else)$/) ? ($item,[],{}) : ('var',pname($item)));
}

sub pname($){
	my($item) = @_;
	my($name,$temp,%opt);

	if($item =~ /^((?:[^\"\'\[\]\s]|\[(?:[^\"\'\]]|([\"\'])(?:[^\\\2]|\\[\\\2])*?\2)*?\])+)(.*?)$/s){ #"
		($temp,$name) = ($3,[{ type => 'var', name => ename($1) }]);
	}else{
		($temp,$name) = ($item =~ /^([\"\'])((?:[^\\\1]|\\[\\\1])*?)\1(.*?)$/s) ? ($3,pexpr(etrim($2,$1))) : ('',pexpr($item)); #"
	}
	while($temp =~ /\s+(\w+)\=(?:([\"\'])((?:[^\\\2]|\\[\\\2])*?)\2|([^\"\'\s]*))(?=(?:\s+|$))/g){ #"
		$opt{$1} = embep(defined($3) ? etrim($3,$2) : $4);
	}

	return($name,\%opt);
}

sub lvars($$){
	my($loop,$cnt) = @_;
	my %lvar = (
		__first__ => 0, __inner__ => 1, __last__ => 0, __odd__ => ($cnt % 2), __index__ => $cnt,
		__counter__ => ($cnt + 1), __prev__  => $cnt, __next__ => ($cnt + 2), __loop__ => $loop,
	);
	@lvar{'__first__','__inner__','__prev__'} = (1,0,0) if($cnt == 0);
	@lvar{'__last__' ,'__inner__','__next__'} = (1,0,0) if($cnt == $#$loop);
	return(%lvar);
}

sub slctb($$$){
	my($check,$false,$vars) = @_;
	my($item);

	foreach $item (@$check){
		return($item->{'true'}) if(getb($item->{'type'},$item->{'name'},$item->{'opt'},$vars));
	}
	return($false);
}

#---

sub pvars($$){
	my($list,$vars) = @_;
	my(@temp,@argt,$item,$name,$args);

	$item = $vars;
	foreach $name (@$list){
		push(@temp,((ref($name->{'name'}) eq 'ARRAY') ? cexpr($name->{'name'},$vars) : $name->{'name'}));
		push(@argt,eargs($name->{'args'},$vars));
	}
	while(defined($name = shift(@temp))){
		($item,$args) = pitem($item,$name,shift(@argt),$vars);
		$item = scalar($item->({},$args,$temp[0],$vars)) if((0 < scalar(@temp)) && (ref($item) eq 'CODE'));
	}
	return($item,$args);
}

sub pitem($$$$){
	my($item,$name,$args,$vars) = @_;

	if(UNIVERSAL::can($item,$name)){
		return(scalar($item->$name(@$args)),[]);
	}elsif(ref($item) eq 'HASH'){
		return($item->{$name},$args);
	}elsif(ref($item) eq 'ARRAY'){
		return($item->[$name-1],$args) if($name =~ /^\d+$/);
		return($item->[$#$item],$args) if($name eq 'last');
		return(scalar(@$item)  ,$args) if($name eq 'length');
		return(undef,$args);
	}elsif(ref($expfunc->{$name}) eq 'CODE'){
		return(scalar($expfunc->{$name}->(evars($item,[],$vars))),$args);
	}else{
		return(undef,$args);
	}
}

sub mkopt($$){
	my($opt,$vars) = @_;
	my($name,$value,%rslt);
	while(($name,$value) = each(%$opt)){ $rslt{$name} = eexpr($value,$vars); }
	return(\%rslt);
}

#---

sub getv($$$){
	my($name,$opt,$vars) = @_;
	my($value,$args);

	($value,$args) = egetv(0,$name,$vars);
	$opt = mkopt($opt,$vars);

	if(ref($value) eq 'CODE'){
		return(scalar($value->($opt,$args,'',$vars)));
	}else{
		return(vtrim(evars($value,$args,$vars),$opt));
	}
}

sub getb($$$$){
	my($type,$name,$opt,$vars) = @_;
	my($value,$args);

	($value,$args) = egetv(0,$name,$vars);
	$opt = mkopt($opt,$vars);

	if((ref($value) eq 'CODE') ? $value->($opt,$args,'',$vars) : cbool(evars($value,$args,$vars),$opt)){
		return(($type eq 'if') ? 1 : 0);
	}else{
		return(($type eq 'if') ? 0 : 1);
	}
}

sub getl($$$$){
	my($name,$opt,$vars,$util) = @_;
	my($value,$args);

	($value,$args) = egetv(1,$name,$vars);
	$opt = mkopt($opt,$vars);

	if(ref($value) eq 'CODE'){
		return(lcheck([ $value->($opt,$args,'',$vars) ],$vars));
	}elsif(ref($value) eq 'ARRAY'){
		return(@{ ltrim([ lcheck($value,$vars) ],$opt,$util) });
	}elsif(ref($value) eq 'HASH'){
		return(@{ ltrim([ $value ],$opt,$util) });
	}else{
		return();
	}
}

#---

sub vtrim($$){
	my($value,$opt) = @_;
	my($max,$fmt,$esc,$def);

	local $_;
	($max) = chkopt($opt,['maxlen'],qr/^(\d+)$/,0);
	($esc) = chkopt($opt,['escape'],qr/^(\w+)$/,'_default_');
	($fmt,$def) = chkopt($opt,['format','default'],qr/^(.+)$/s,'');
	$esc = $esclist->{$esc};

	$value = $def if(!(defined($value) && ($value ne '')));
	$value = (substr($value,0,($max - 4)) . ' ...') if((0 < $max) && ($max < length($value)));
	$value = sprintf($fmt,$value) if($fmt =~ /\S/);

	if(ref($esc) eq 'HASH'){
		foreach(@{$esc->{'list'} || []}){ $value =~ s/\Q$_->[0]\E/$_->[1]/g; }
		$esc->{'code'}->($value) if(ref($esc->{'code'}) eq 'CODE');
	}

	return($value);
}

sub cbool($$){
	my($value,$opt) = @_;
	my @clist = ('eq','ne','lt','gt','le','ge','mod','match');
	my %alias = (lt => '<', gt => '>', le => '<=', ge => '>=', mod => '%', match => '=~');

	local $_;
	foreach(@clist){ return($explist->{$alias{$_} || $_}->($value,$opt->{$_})) if(defined($opt->{$_})); }
	return($value ? 1 : 0);
}

sub ltrim($$$){
	my($value,$opt,$util) = @_;
	my($num,$off,$last,$expr,$sort,$group,$block);

	($num,$off,$last,$block) = chkopt($opt,['num','off','last','block'],qr/^(\d+)$/,0);
	($expr,$sort,$group) = chkopt($opt,['expr','sort','group'],qr/^(.+)$/s,'');

	egrep(pexpr($expr),$value,$util) if($expr =~ /\S/);
	esort(pexpr($sort),$value,$util) if($sort =~ /\S/);
	($num,$off) = ($last,(scalar(@$value) - $last)) if((0 < $last) && ($last < scalar(@$value)));

	splice(@$value,0,$off) if( 0 < $off);
	$#$value = ($num - 1)  if((0 < $num) && ($num < scalar(@$value)));
	@$value  = reverse(@$value) if($opt->{'rev'});
	egroup(pexpr($group),$value,$util) if($group =~ /\S/);
	eblock($block,$value)  if( 0 < $block);

	return($value);
}

#---

sub lcheck($$){
	my($list,$vars) = @_;
	my(@temp);

	@temp = (ref($list->[0]) eq 'ARRAY') ? @{$list->[0]} : @$list;
	@temp = map { (ref($_) eq 'CODE') ? $_->({},[],'',$vars) : $_ } @temp;
	@temp = map { (ref($_) eq 'HASH') ? $_ : defined($_) ? ({ item => $_ }) : () } @temp;
	return(@temp);
}

sub chkopt($$$$){
	my($opt,$name,$chk,$def) = @_;
	return(map { (defined($opt->{$_}) && ($opt->{$_} =~ /$chk/)) ? $1 : $def } @$name);
}

#---

sub pexpr($){
	my($text) = @_;
	my(@temp,@tobj,$tree,$item,@list);

	while($text =~ /((?:[\(\)\?\:])|(?:\-?\d[\d\.]*)|(?:\&\&|\|\||\=[\=\~]|\![\=\~]?|[\<\>]\=?|[\+\-\*\/\%])|(?:(?:[\w\.]|\[(?:[^\"\'\]]|([\"\'])(?:[^\\\2]|\\[\\\2])*?\2)*?\])+)|(?:([\"\'])(?:(?:[^\\\3]|\\[\\\3])*?)\3))/g){ push(@temp,$1); } #"
	$tree = \@tobj;
	undef $text;

	while(defined($item = shift(@temp))){
		if(    $item eq '('){ push(@list,$tree); push(@$tree,[]); $tree = $tree->[-1];
		}elsif($item eq ')'){ $tree = pop(@list) if(0 < scalar(@list));
		}elsif($item eq '?'){ push(@$tree,{ type => 'tri1' });
		}elsif($item eq ':'){ push(@$tree,{ type => 'tri2' });
		}elsif($item =~ /^\-?\d[\d\.]*$/){ push(@$tree,$item);
		}elsif((lc($item) eq 'and') || ($item eq '&&')){ push(@$tree,{ type => 'and' });
		}elsif((lc($item) eq 'or' ) || ($item eq '||')){ push(@$tree,{ type => 'or'  });
		}elsif($explist->{$item}){ push(@$tree,{ type => 'expr', expr => $item });
		}elsif($expfunc->{$item}){ push(@$tree,{ type => 'func', func => $item });
		}elsif($item =~ /^(?:[\w\.]|\[(?:[^\"\'\]]|([\"\'])(?:[^\\\1]|\\[\\\1])*?\1)*?\])+$/){ #"
			push(@$tree,{ type => 'var', name => ename($item) });
		}elsif($item =~ /^([\"\'])((?:[^\\\1]|\\[\\\1])*?)\1$/){ push(@$tree,etrim($2,$1));  } #"
	}

	return(\@tobj);
}

sub cexpr($$){
	my($tree,$vars) = @_;
	my @tree = @$tree;
	my $qlen = scalar(@tree);

	return(eitem($tree[0],$vars)) if($qlen == 1);
	return(eitem($tree[0],$vars)  ? eitem($tree[2],$vars) : eitem($tree[4],$vars)) if(($qlen == 5) && etype($tree[1],'tri1') && etype($tree[3],'tri2'));
	return(eitem($tree[0],$vars) && eitem($tree[2],$vars)) if(($qlen == 3) && etype($tree[1],'and'));
	return(eitem($tree[0],$vars) || eitem($tree[2],$vars)) if(($qlen == 3) && etype($tree[1],'or' ));
	return(scalar($explist->{$tree[1]->{'expr'}}->(eitem($tree[0],$vars),eitem($tree[2],$vars)))) if(($qlen == 3) && etype($tree[1],'expr'));
	return(scalar($expfunc->{$tree[0]->{'func'}}->(eitem($tree[1],$vars)))) if(($qlen == 2) && etype($tree[0],'func'));
	return(cexpr([ @tree[0 .. 3],[ @tree[4 .. $#tree] ] ],$vars)) if((6 <= $qlen) && etype($tree[1],'tri1') && etype($tree[3],'tri2'));
	return(cexpr([ cexpr([ @tree[0 .. 2] ],$vars),@tree[3 .. $#tree] ],$vars)) if((4 <= $qlen) && (etype($tree[1],'expr') || etype($tree[1],'and') || etype($tree[1],'or')));
	return(cexpr([ cexpr([ @tree[0 .. 1] ],$vars),@tree[2 .. $#tree] ],$vars)) if((3 <= $qlen) &&  etype($tree[0],'func'));
	return(undef);
}

#---

sub egrep($$$){
	my($tobj,$list,$util) = @_;
	@$list = @{$list}[ (grep { cexpr($tobj,{ %$util,lvars($list,$_),%{$list->[$_]} }) } (0 .. $#$list)) ];
}

sub esort($$$){
	my($tobj,$list,$util) = @_;
	my @temp = map { cexpr($tobj,{ %$util,lvars($list,$_),%{$list->[$_]} }) } (0 .. $#$list);
	my $comp = (grep { !/^\-?\d[\d\.]*$/ } @temp) ? (sub { $_[0] cmp $_[1] }) : (sub { $_[0] <=> $_[1] });
	@$list = @{$list}[ (sort { $comp->($temp[$a],$temp[$b]) || ($a <=> $b)  } (0 .. $#$list)) ];
}

sub egroup($$$){
	my($tobj,$list,$util) = @_;
	my(@temp,%hash,$name,$cnt);
	foreach $cnt (0 .. $#$list){
		$name = cexpr($tobj,{ %$util,lvars($list,$cnt),%{$list->[$cnt]} });
		push(@temp,($hash{$name} = { name => $name, list => [] })) if(!$hash{$name});
		push(@{$hash{$name}->{'list'}},$list->[$cnt]);
	}
	@$list = @temp;
}

sub eblock($$){
	my($bnum,$list) = @_;
	my(@temp);
	while(0 < scalar(@$list)){ push(@temp,[ splice(@$list,0,$bnum) ]); }
	@$list = map { ({ name => ($_ + 1), list => $temp[$_] }) } (0 .. $#temp);
}

#---

sub etype($$){
	my($item,$type) = @_;
	return((ref($item) eq 'HASH') && ($item->{'type'} eq $type));
}

sub eitem($$){
	my($item,$vars) = @_;
	return((ref($item) eq 'ARRAY') ? cexpr($item,$vars) : etype($item,'var') ? evars(pvars($item->{'name'},$vars),$vars) : (ref($item) eq '') ? etext($item,$vars) : undef);
}

sub evars($$$){
	my($item,$args,$vars) = @_;
	($item,$args) = (scalar($item->({},$args,'',$vars)),[]) if(ref($item) eq 'CODE');
	return(((ref($item) eq 'SCALAR') || (ref($item) eq 'REF')) ? evars($$item,$args,$vars) : (ref($item) eq 'ARRAY') ? scalar(@$item) : (ref($item) eq '') ? $item : 1);
}

sub egetv($$$){
	my($mode,$item,$vars) = @_;
	my($value,$args);
	if(($mode == 1) && (scalar(@$item) == 1) && eichk($item->[0])){
		($value,$args) = pvars($item->[0]->[0]->{'name'},$vars);
		return([ $value->({},$args,'',$vars) ],[]);
	}
	return(pvars($item->[0]->{'name'},$vars)) if(eichk($item));
	return(cexpr($item,$vars),[]);
}

sub ename($){
	my($item) = @_;
	my(@list,$name,$temp,$args);
	while($item =~ /(?:^|\.+)(?:\[((?:[^\"\'\]]|([\"\'])(?:[^\\\2]|\\[\\\2])*?\2)*?)\]|([^\[\]\s\.]+))(?:\[((?:[^\"\'\]]|([\"\'])(?:[^\\\5]|\\[\\\5])*?\5)*?)\])?(?=(?:\.+|$))/g){ #"
		$temp = defined($4) ? $4 : '';
		$name = defined($1) ? pexpr($1) : $3;
		$args = [];
		while($temp =~ /((?:[^\"\'\,]|([\"\'])(?:[^\\\2]|\\[\\\2])*?\2)+)/g){ push(@$args,pexpr($1)); } #"
		push(@list,{ name => $name, args => $args });
	}
	return(\@list);
}

sub eargs($$){
	my($item,$vars) = @_;
	return((ref($item) eq 'ARRAY') ? ([ (map { (ref($_) eq 'ARRAY') ? cexpr($_,$vars) : $_ } @$item) ]) : []);
}

sub embep($){
	my($item) = @_;
	my(@temp);
	while($item =~ /(?:\\([\\\%]))|([^\\\%]+)|\%\{((?:[^\"\'\}]|([\"\'])(?:[^\\\4]|\\[\\\4])*?\4)*?)\}|([\\\%])/g){ #"
		push(@temp,(defined($1) ? $1 : defined($2) ? $2 : defined($3) ? pexpr($3) : $5));
	}
	return(\@temp);
}

sub eexpr($$){
	my($item,$vars) = @_;
	return($item) if(ref($item) ne 'ARRAY');
	my @temp = map { (ref($_) eq 'ARRAY') ? cexpr($_,$vars) : $_ } @$item;
	return((scalar(@temp) == 1) ? $temp[0] : join('',@temp));
}

sub etext($$){
	my($item,$vars) = @_;
	return(($item =~ /\%\{/) ? evars(eexpr(embep($item),$vars),[],$vars) : $item);
}

sub etrim($$){
	my($item,$esc) = @_;
	my(@temp);
	$esc = qr/\\([\\$esc])|([^\\$esc]+)|([\\$esc])/;
	while($item =~ /$esc/g){ push(@temp,(defined($1) ? $1 : defined($2) ? $2 : $3)); }
	return(join('',@temp));
}

sub eichk($){
	my($item) = @_;
	return((ref($item) eq 'ARRAY') && (scalar(@$item) == 1) && etype($item->[0],'var'));
}

#---

sub readt($$$$){
	my($path,$ichk,$ltag,$rtag) = @_;
	my($text);

	((-f $path) && (++$ichk < 4)) || return('');
	$text = readf($path);
	$text =~ s/(?:\t*)(?:$ltag)\s*(?:include\=([\"\']?)([\w\-\.\/]+)\1)\s*(?:$rtag)(?:\n?)/readt(fpath($2,$path),$ichk,$ltag,$rtag)/eg; #"
	return($text);
}

sub readf($){
	my($path) = @_;
	my($text);

	local *R;
	((-f $path) && open(R,"< $path")) || return('');
	flock(R,1);
	read(R,$text,-s _);
	close(R);
	return($text);
}

sub fpath($$){
	my($path,$icld) = @_;
	my(@temp);

	return($path) if(index($path,'/') == 0);

	local $_;
	@temp = split(/\/+/,$icld);
	pop(@temp);
	foreach(split(/\/+/,$path)){
		next if(!/^[\w\-\.]+$/);
		pop(@temp) if($_ eq '..');
		next if(/^\.+$/);
		push(@temp,$_);
	}

	return(join('/',@temp) || './dummy.tmpl');
}

#---

sub esclist(){
	return({
		html => { list => [ ['&' ,'&amp;'],['<','&lt;'],['>','&gt;'],['"','&quot;'],['\'','&#39;'] ], },
		js   => { list => [ ['\\','\\\\' ],['/','\\/' ],['%', '\\%'],['"',    '\"'],['\'', '\\\''] ], code => sub { $_[0] =~ s/\n/\\n/g; }, },
		url  => { code => sub { $_[0] =~ s/([^\w\s])/'%' . unpack('H2',$1)/eg; $_[0] =~ s/\s/\+/g; }, },
		mail => { list => [ ['@','&#64;'],['.','&#46;'] ], },
	});
}

sub explist(){
	return({
		'==' => sub { $_[0] == $_[1] }, '!=' => sub { $_[0] != $_[1] }, '>'  => sub { $_[0]  > $_[1] }, '<'  => sub { $_[0]  < $_[1] }, '>=' => sub { $_[0] >= $_[1] }, '<=' => sub { $_[0] <=  $_[1]  },
		'eq' => sub { $_[0] eq $_[1] }, 'ne' => sub { $_[0] ne $_[1] }, 'lt' => sub { $_[0] lt $_[1] }, 'gt' => sub { $_[0] gt $_[1] }, 'le' => sub { $_[0] le $_[1] }, 'ge' => sub { $_[0] ge  $_[1]  },
		'+'  => sub { $_[0]  + $_[1] }, '-'  => sub { $_[0]  - $_[1] }, '*'  => sub { $_[0]  * $_[1] }, '/'  => sub { $_[0]  / $_[1] }, '%'  => sub { $_[0]  % $_[1] }, '=~' => sub { $_[0] =~ /$_[1]/ }, '!~' => sub { $_[0] !~ /$_[1]/ },
	});
}

sub expfunc(){
	return({
		'!' => sub { $_[0] ? 0 : 1 }, 'not' => sub { $_[0] ? 0 : 1 }, 'defined' => sub { defined($_[0]) }, 'length' => sub { length($_[0]) }, 'int' => sub { int($_[0]) }, 'abs' => sub { abs($_[0]) },
	});
}

#---
1;
